package blog.debug

import blog.model.Model
import blog.world.PartialWorld
import blog.bn.VarWithDistrib

/**
 * A sample generated by MHSampler.
 *
 * @author cberzan
 * @since Jun 23, 2014
 */
class MHSample(
  model: Model,
  world: PartialWorld,
  val accepted: Boolean,
  val chosenVar: VarWithDistrib,
  val chosenVarOldValue: Object,
  val chosenVarNewValue: Object,
  val logProposalBackward: Double,
  val logProposalForward: Double,
  val logProbRatio: Double,
  val logAcceptRatio: Double)
  extends Sample(model, world) {

  override def toString = s"MHSample(accepted: ${accepted}, world: ${world})"

  // For MH, all samples have weight 1, i.e. log-weight 0.
  def logWeight: Double = 1.0

  def dump = {
    println(s"MHSample:")
    println(s"world: ${world}")
    println(s"accepted: ${accepted}")
    println(s"chosenVar: ${chosenVar}")
    println(s"chosenVarOldValue: ${chosenVarOldValue}")
    println(s"chosenVarNewValue: ${chosenVarNewValue}")
    println(s"logProposalBackward: ${logProposalBackward}")
    println(s"logProposalForward: ${logProposalForward}")
    println(s"logProbRatio: ${logProbRatio}")
    println(s"logAcceptRatio: ${logAcceptRatio}")
    println
  }
}